import { defineComponent as c, openBlock as o, createElementBlock as d, createElementVNode as t, Fragment as m, renderList as u, withDirectives as p, toDisplayString as f, normalizeStyle as _, createCommentVNode as l, vShow as g } from "vue";
const v = (e, s) => {
  const n = e.__vccOpts || e;
  for (const [h, a] of s)
    n[h] = a;
  return n;
}, w = c({
  name: "PanelMap",
  props: {
    src: String,
    map: Object
  },
  data() {
    return {
      hoveron: !1,
      displayFooter: !1,
      instrumentImage: null,
      description: void 0,
      title: "",
      imgWidth: 0,
      //the natural image width
      width: 0,
      // the image width as displayed
      cardImgWidth: "",
      cardImgDefaultWidth: "10rem"
    };
  },
  mounted() {
    this.width = window.innerWidth - 480, window.addEventListener("resize", this.onResize);
  },
  beforeDestroy() {
    window.removeEventListener("resize", this.onResize);
  },
  methods: {
    initValues() {
      this.imgWidth = this.$refs.img.naturalWidth;
    },
    onResize() {
      this.width = window.innerWidth - 480;
    },
    extendedArea(e) {
      const s = this.scaleCoords(e.coords);
      return { ...e, scaledCoords: s };
    },
    scaleCoords(e) {
      const s = this.width && this.imgWidth && this.imgWidth > 0 ? this.width / this.imgWidth : 1;
      return e.map((n) => n * s);
    },
    handleMouseEnter(e, s) {
      arguments.length < 2 || e.nodisplay != !0 && (e.img === void 0 && (this.instrumentImage = void 0), e.href !== void 0 && (this.displayFooter = !0), this.hoveron = !0, this.instrumentImage = e.img, this.description = e.text, this.title = e.title, e.width ? this.cardImgWidth = e.width : this.cardImgWidth = this.cardImgDefaultWidth);
    },
    handleMouseLeave(e, s) {
      this.hoveron = !1, this.displayFooter = !1;
    }
  }
}), y = { class: "container-fluid" }, M = { class: "row" }, W = { class: "col" }, I = ["src", "useMap", "width"], k = ["name"], L = ["id", "coords", "shape", "href", "onMouseenter", "onMouseleave"], C = { class: "col p-3" }, $ = { class: "card" }, z = { class: "card-header" }, E = {
  key: 0,
  class: "d-flex justify-content-center my-4"
}, b = ["src", "alt"], D = { class: "card-body" }, F = { class: "card-text" }, A = ["innerHTML"], S = {
  key: 1,
  class: "card-footer"
};
function V(e, s, n, h, a, j) {
  return o(), d("div", y, [
    t("div", M, [
      t("div", W, [
        t("img", {
          ref: "img",
          src: e.src,
          onLoad: s[0] || (s[0] = (i) => e.initValues()),
          useMap: `#${e.map.name}`,
          width: e.width
        }, null, 40, I),
        t("map", {
          name: e.map.name
        }, [
          (o(!0), d(m, null, u(e.map.areas, (i) => (o(), d("area", {
            key: i.id,
            id: i.id,
            coords: e.extendedArea(i).scaledCoords.join(","),
            shape: i.shape,
            href: i.href,
            onMouseenter: (r) => e.handleMouseEnter(e.extendedArea(i), r),
            onMouseleave: (r) => e.handleMouseLeave(e.extendedArea(i), r),
            alt: "map",
            target: "_blank"
          }, null, 40, L))), 128))
        ], 8, k)
      ]),
      p(t("div", C, [
        t("div", $, [
          t("h5", z, f(this.title), 1),
          this.instrumentImage ? (o(), d("div", E, [
            t("img", {
              src: this.instrumentImage,
              style: _({ width: this.cardImgWidth }),
              alt: this.title
            }, null, 12, b)
          ])) : l("", !0),
          t("div", D, [
            t("p", F, [
              t("span", {
                innerHTML: this.description
              }, null, 8, A)
            ])
          ]),
          e.displayFooter ? (o(), d("h6", S, " Click to open the manual")) : l("", !0)
        ])
      ], 512), [
        [g, e.hoveron]
      ])
    ])
  ]);
}
const R = /* @__PURE__ */ v(w, [["render", V]]);
export {
  R as default
};
